#!/usr/bin/env node
var moment = require('moment');

require('./sitegin/sitegin')({
  watch: false
})
.then(function onLoad(jobs) {
  var sass = require('node-sass');
  var fs = require('fs');

  var isRunning = false;
  var runAgain = false;

  function run() {
    var startTime = moment();
    runAgain = false;
    if(isRunning) {
      console.log("Generator is still running. Queing another run after it finishes.")
      runAgain = true;
      return;
    }
    console.log("================================================================================")
    console.log("Running generator")
    isRunning = true;
    jobs.run('pipeline',jobs)
    .then(function() {
      isRunning = false;
      console.log("Generator finished in",moment().diff(startTime,'seconds'),'seconds')
      if(runAgain) run();
    })
    .catch(function(e) {
      isRunning = false;
      console.log("Generator crashed in",moment().diff(startTime,'seconds'),'seconds')
      if(runAgain) run();
      console.log(e.stack)
    });
  }

  console.log('Sitegin successfully loaded');
  jobs.onReload(function() {
    console.log("Sitegin reloaded");
    run();
  })
  run();
})
.catch(function(e) {
  console.log(e.stack);
  process.exit();
});
